package de.aes.camdroid;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.hardware.Camera;
import android.os.Bundle;
import android.view.Display;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.TextView;
import de.test.R;




/**
 * Clase principal en donde se ejecutan las acciones del programa
 * @author Catrileo,Quiroz,Rodriguez
 *
 */
public class main extends Activity implements Runnable, OnClickListener
{
	public static Context context;
	public static byte[] currentJPEG;
	
	WebServer webServer;
	private Thread webService;
	private Thread main;
	private boolean isMainRunning=false;
	private synchronized boolean isMainRunning()
	{ return isMainRunning;}
	private synchronized void isMainRunning(boolean bool)
	{isMainRunning = bool;}
	
	private Settings settings;
	private boolean isResuming=false;
	
	//// Devices
	private Camera cameraDevice;
	private Display displayDevice;
			
	//// Layout
	private FrameLayout mainFrame;
	private FrameLayout borderFrame;
	private CameraView cameraFrame;
	private FrameLayout hiddenFrame;
	private int ctlElementWidth;
	
	//// Resolution Config Frame
	@SuppressWarnings("unused")
	private Button resMax;
	@SuppressWarnings("unused")
	private Button resMin;
	private TextView resText;
	@SuppressWarnings("unused")
	private Button resPrev;
	@SuppressWarnings("unused")
	private Button resNext;
	
	//// Frames Config Frame
	@SuppressWarnings("unused")
	private Button frmMax;
	@SuppressWarnings("unused")
	private Button frmMin;
	private TextView frmText;
	@SuppressWarnings("unused")
	private Button frmPrev;
	@SuppressWarnings("unused")
	private Button frmNext;
	
	//// JPEG Quality Config Frame
	@SuppressWarnings("unused")
	private Button jpgMin10;
	@SuppressWarnings("unused")
	private Button jpgMin1;
	private TextView jpgText;
	@SuppressWarnings("unused")
	private Button jpgPlus1;
	@SuppressWarnings("unused")
	private Button jpgPlus10;
	
	//// Socket Config Frame
	@SuppressWarnings("unused")
	private TextView sckDummy1;
	@SuppressWarnings("unused")
	private TextView sckDummy2;
	@SuppressWarnings("unused")
	private TextView sckText;
	private EditText sckEdit;
	@SuppressWarnings("unused")
	private Button sckSet;
	
	//// Menu Controls Frame
	@SuppressWarnings("unused")
	private Button menuRes;
	@SuppressWarnings("unused")
	private Button menuFrm;
	@SuppressWarnings("unused")
	private Button menuJpg;
	@SuppressWarnings("unused")
	private Button menuSck;
	private Button menuAct;
	
	//// OSD
	private FrameLayout osd;
	private TextView osdFps;
	private TextView osdState;
	private TextView osdInterface;
	
	private String mFlagRegister = "0000";
	
/**
 * Metodo del estado "Running"
 */
	@Override
	public void run()
	{
		isMainRunning(true);
		double deltaT0=0;
		boolean recState=true;
		double deltaT1=0;
		double fps_cnt=0;
		
		setText(osdState, " R E C ");
		setText(osdFps, " 0 fps ");
		
		while (isMainRunning())
		{
			final double dateT1 = new Date().getTime();
			currentJPEG = cameraFrame.getPicture();
			final double dateT2 = new Date().getTime();
			
			fps_cnt += 1;
			deltaT1 += dateT2 - dateT1;
			deltaT0 += dateT2 - dateT1;
			
			if (deltaT0 >= 1000)
			{
				if (!recState)
				{
					recState = true;
					setText(osdState, " R E C ");
				}
				else
				{
					recState = false;
					setText(osdState, "       ");
				}
				deltaT0 = 0;				
			}
			
			if (deltaT1 >= 250)
			{
				final String fps =
					Integer.toString((int)(1000 * fps_cnt / deltaT1));
				
				setText(osdFps, " " + fps + " fps ");
								
				fps_cnt=0;
				deltaT1 = 0;
			}
		}
		setText(osdState, "");
		setText(osdFps, "");
	}
/**
 * Inicializador de la interfaz grafica
 */
	public void init()
	{
		context = this;
		WindowManager windowManager = (WindowManager)getSystemService(Context.WINDOW_SERVICE);
		
		//// Devices
		cameraDevice = Camera.open();
		displayDevice = windowManager.getDefaultDisplay();
		
		//// Settings
		settings = new Settings(this, cameraDevice.getParameters());
		
		//// Layout
		mainFrame =	(FrameLayout)findViewById(R.id.mainFrame);
		borderFrame = (FrameLayout)findViewById(R.id.borderFrame);
		osd = (FrameLayout)findViewById(R.id.osd);
		hiddenFrame = (FrameLayout)findViewById(R.id.hiddenFrame);
		cameraFrame = new CameraView
			(this, cameraDevice, displayDevice, osd, borderFrame, settings);
		
		mainFrame.addView(cameraFrame, 1);
		mainFrame.setOnClickListener(this);
		
		ctlElementWidth = (int)((double)displayDevice.getWidth()*0.19);
        
        String label = new String();
        
		// Resolution Config Frame
        label = "Resolution\n" +
        	String.format("%d x %d", settings.PictureW(), settings.PictureH());
        resMin	= initButton(R.id.resMin);
        resMax	= initButton(R.id.resMax);
        resPrev = initButton(R.id.resPrev);
        resNext = initButton(R.id.resNext);
        resText = initTextView(R.id.resText, label);
                
        // Frames Config Frame
        label = String.format("Frequency\n%d fps",settings.FrameRate());
        frmMax = initButton(R.id.frmMax);
        frmMin = initButton(R.id.frmMin);
        frmPrev = initButton(R.id.frmPrev);
        frmNext = initButton(R.id.frmNext);
        frmText = initTextView(R.id.frmText, label);
        
    	// JPEG Quality Config Frame
        label = String.format("Quality\n%d %%", settings.PictureQ());
        jpgMin10 = initButton(R.id.jpgMin10);
        jpgMin1 = initButton(R.id.jpgMin1);
        jpgPlus1 = initButton(R.id.jpgPlus1);
        jpgPlus10 = initButton(R.id.jpgPlus10);
        jpgText = initTextView(R.id.jpgText, label);
        
    	// Socket Config Frame
        label = "Port";
        sckSet = initButton(R.id.sckSet);
        sckEdit = (EditText)findViewById(R.id.sckEdit);
        sckEdit.setText(String.valueOf(settings.webPort()));
        sckEdit.setWidth(ctlElementWidth);
        sckDummy1 = initTextView(R.id.sckDummy1);
        sckDummy2 = initTextView(R.id.sckDummy2);
        sckText = initTextView(R.id.sckText, label);
        
        // Menu Controls Frame
        menuRes = initButton(R.id.menuRes);
        menuFrm = initButton(R.id.menuFrm);
        menuJpg = initButton(R.id.menuJpg);
        menuSck = initButton(R.id.menuSck);
        menuAct = initButton(R.id.menuAct);
        
        // OSD
        osdFps = initTextView(R.id.fpsOSD);
        osdState = initTextView(R.id.stateOSD);
        osdInterface = (TextView)findViewById(R.id.interfaceOSD);
        
        buildResources();
        
        showControls(mFlagRegister);
	}
/**
 * Crea los elementos necesarios que serviran al servidor	
 */
	private void buildResources()
	{
		try
		{
			String[] str = { "mkdir", this.getFilesDir().toString() };
			Process ps = Runtime.getRuntime().exec(str);
			ps.waitFor();
		}
		catch (Exception e) {}
		try
		{
			copyResourceFile(R.raw.index, "index.html");
		}
		catch (Exception e) {}
	}
/**
 * Establece el tamao del buffer que contendra las imagenes
 * @param rid
 * @param targetFile
 * @throws IOException
 */
	private void copyResourceFile(int rid, String targetFile) throws IOException
	{
		InputStream fin = ((Context) this).getResources().openRawResource(rid);
		FileOutputStream fos = main.this.openFileOutput(targetFile, Context.MODE_PRIVATE);

		int length;
		byte[] buffer = new byte[1024 * 32];
		while ((length = fin.read(buffer)) != -1)
		{
			fos.write(buffer, 0, length);
		}
		fin.close();
		fos.close();
	}
/**
 * Inicia boton
 * @param Id
 * @return Button
 */
	private Button initButton(int Id)
	{
		Button button = (Button)findViewById(Id);
		button.setWidth(ctlElementWidth);
		button.setOnClickListener(this);
		return button;
	}
/**
 * Despliega texto	
 * @param Id
 * @param text
 * @return TextView
 */
	private TextView initTextView(int Id, String text)
	{
		TextView textView = (TextView)findViewById(Id);
		textView.setWidth(ctlElementWidth);
		
		if (text != null) textView.setText(text);
		
		return textView;
	}
/**
 * Despliega texto	
 * @param Id
 * @return TextView
 */
	private TextView initTextView(int Id)
	{
		return initTextView(Id, null);
	}
/**
 * Setea texto	
 * @param tv
 * @param s
 */
	private void setText(final TextView tv, final String s)
	{
		runOnUiThread(new Runnable(){
			
			@Override
			public void run() {
				tv.setText(s);
			}});
	}
/**
 * Pone texto en boton	
 * @param b
 * @param s
 */
	@SuppressWarnings("unused")
	private void setText(final Button b, final String s)
	{
		runOnUiThread(new Runnable(){
			
			@Override
			public void run() {
				b.setText(s);
			}});
	}
/**
 * Detiene, limpia la configuracion y libera la camara. Es el ultimo metodo llamado antes de salir de programa.	
 */
	public void cleanUp ()
	{
		isMainRunning(false);
		WebServer.isServiceRunning(false);
		
		cameraFrame.stopPreview();		
		cameraDevice.release();
		
		settings.saveConfig();
	}
/**
 * Crea el layout principal	
 */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		init();		
    }
/**
 * Detiene momentaneamente la accion de Start	
 */
    @Override
	protected void onResume()
    {
    	super.onResume();
    	if (isResuming)
    	{
    		stopService(new Intent(main.this, NotificationService.class));
    		isResuming=false;
    	}
    }
/**
 * Pausa la accion de Start  
 */
    @Override
	protected void onPause()
    {
    	super.onPause();
    	isResuming = true;
    	startService(new Intent(main.this, NotificationService.class));
    }
/**
 * Termina la accion de Start    
 */
    @Override
	protected void onDestroy()
    {
    	super.onDestroy();
    	cleanUp();
    }
    
/**
 * Accion que realiza el boton "atras" del celular. En este caso cierra el programa    
 */
    @Override
	public void onBackPressed()
    {
    	super.onBackPressed();
    	cleanUp();
    	System.exit(0);
    }
/**
 * Genera la accion correspondiente al hacer click en un boton    
 */
	@Override
	public void onClick(View v) {
		
		int buttonId = v.getId();
		
		switch (buttonId)
		{
			case R.id.menuRes:		showControls("1000");	break;
			case R.id.menuFrm:		showControls("0100");	break;
			case R.id.menuJpg:		showControls("0010");	break;
			case R.id.menuSck:		showControls("0001");	break;
			case R.id.menuAct:		buttonStart(); 			break;
			
			case R.id.jpgMin10:		picQuality(-10); 		break;
			case R.id.jpgMin1:		picQuality(-1);			break;
			case R.id.jpgPlus1:		picQuality(+1);			break;				
			case R.id.jpgPlus10:	picQuality(+10);		break;
							
			case R.id.frmMin:		FrameRate(-2);			break;
			case R.id.frmPrev:		FrameRate(-1);			break;
			case R.id.frmNext:		FrameRate(+1);			break;
			case R.id.frmMax:		FrameRate(+2);			break;		
			
			case R.id.resMin:		Resolution(-2);			break;
			case R.id.resPrev:		Resolution(-1);			break;
			case R.id.resNext:		Resolution(+1);			break;
			case R.id.resMax:		Resolution(+2);			break;
			
			case R.id.sckSet:		setPort();				break;
			
			default:				hideControls();			break;
		}
		
	}
/**
 * Inicia la comunicacion con el webserver e inicia la transmisin 	
 */
	private void buttonStart()
	{
		if (!isMainRunning())
		{
			webServer = new WebServer();
			WebServer.callBacker = main.this;
			WebServer.port = settings.webPort();
			webService = new Thread(webServer);
			webService.start();
			String url = " http://" + WebServer.getInterfaces() +
				":" + settings.webPort() + "/motion.jpg";
			osdInterface.setText(url);
			
			main = new Thread(this);
			main.start();
			
			menuAct.setText("STOP!");
		}
		else
		{
			isMainRunning(false);
			WebServer.isServiceRunning(false);
			webService = null;
			webServer = null;
			osdInterface.setText("");
			menuAct.setText("Start");
		}
	}
/**
 * Despliega seteo de calidad de imagen	
 * @param param
 */
    private void picQuality(int param)
    {
      	settings.PictureQ(param);
    	
    	jpgText.setText(	String.format(	"Quality\n%d %%",
    										settings.PictureQ()	)	);
    };
/**
 * Despliega seteo de framerate    
 * @param param
 */
    private void FrameRate(int param)
    {
      	cameraFrame.stopPreview();
    	
    	switch(param)
    	{
    	default:
    	case -2:	settings.minFrmRate();
					break;
					
    	case -1:	settings.PicFrmId(+1);
    				break;
    				
    	case +1:	settings.PicFrmId(-1);
    				break;
    				
    	case +2:	settings.maxFrmRate();
					break;
    	}
    	
    	frmText.setText(	String.format(	"Frequency\n%d fps",
    										settings.FrameRate()	)	);
    	
    	cameraFrame.setFrameRate(settings.FrameRate());
    	cameraFrame.startPreview();
    };  
/**
 * Despliega seteo de resolucion
 * @param param
 */
    private void Resolution(int param)
    {
    	cameraFrame.stopPreview();
    	
    	switch(param)
    	{
    	default:
    	case -2:	settings.minPicRes();
					break;
					
    	case -1:	settings.PicResId(+1);
    				break;
    				
    	case +1:	settings.PicResId(-1);
    				break;
    				
    	case +2:	settings.maxPicRes();
					break;
    	}
    	
    	resText.setText(	String.format(	"Resolution\n%d x %d",
    										settings.PictureW(),
    										settings.PictureH()	)	);
    	cameraFrame.setResolution(settings.PictureW(), settings.PictureH());
    	cameraFrame.startPreview();
    }
/**
 * Despliega seteo de puerto    
 */
    public void setPort()
    {
    	if (sckEdit.getText().toString() != "")
    		settings.webPort(Integer.valueOf(sckEdit.getText().toString()));
    }
/**
 * Muestra controles    
 * @param flags
 */
    public void showControls (String flags) {
    	
    	if (flags == mFlagRegister) flags = "0000";
    	
    	if (flags.charAt(0)=='1')
    		findViewById(R.id.resolution).setVisibility(View.VISIBLE);
    	else
    		findViewById(R.id.resolution).setVisibility(View.GONE);
    	
    	if (flags.charAt(1)=='1')
    		findViewById(R.id.frames).setVisibility(View.VISIBLE);
    	else
    		findViewById(R.id.frames).setVisibility(View.GONE);
    	
    	if (flags.charAt(2)=='1')
    		findViewById(R.id.jpegquali).setVisibility(View.VISIBLE);
    	else
    		findViewById(R.id.jpegquali).setVisibility(View.GONE);
    	
    	if (flags.charAt(3)=='1')
    		findViewById(R.id.socket).setVisibility(View.VISIBLE);
    	else
    		findViewById(R.id.socket).setVisibility(View.GONE);
    	
    	if (flags != "0000")
    		findViewById(R.id.config).setVisibility(View.VISIBLE);
    	else
    		findViewById(R.id.config).setVisibility(View.GONE);
    	
    	mFlagRegister = flags;
    }
/**
 * Esconde controles    
 */
    public void hideControls ()
    {
    	if (hiddenFrame.getVisibility() != View.VISIBLE)
    	{
    		hiddenFrame.setVisibility(View.VISIBLE);
    	}
    	else
    	{
    		hiddenFrame.setVisibility(View.GONE);
    	}
    }
}

